## 2. Machine Learning for Regression

- 2.1 [Car price prediction project](01-car-price-intro.md)
- 2.2 [Data preparation](02-data-preparation.md)
- 2.3 [Exploratory data analysis](03-eda.md)
- 2.4 [Setting up the validation framework](04-validation-framework.md)
- 2.5 [Linear regression](05-linear-regression-simple.md)
- 2.6 [Linear regression: vector form](06-linear-regression-vector.md)
- 2.7 [Training linear regression: Normal equation](07-linear-regression-training.md)
- 2.8 [Baseline model for car price prediction project](08-baseline-model.md)
- 2.9 [Root mean squared error](09-rmse.md)
- 2.10 [Using RMSE on validation data](10-car-price-validation.md)
- 2.11 [Feature engineering](11-feature-engineering.md)
- 2.12 [Categorical variables](12-categorical-variables.md)
- 2.13 [Regularization](13-regularization.md)
- 2.14 [Tuning the model](14-tuning-model.md)
- 2.15 [Using the model](15-using-model.md)
- 2.16 [Car price prediction project summary](16-summary.md)
- 2.17 [Explore more](17-explore-more.md)
- 2.18 [Homework](homework.md)



## Community notes

Did you take notes? You can share them here (or in each unit separately)

* [Notes from Edward](https://edwardcodes.github.io/posts/lr-normal-equation/)
* [Notes from Kwang Yang](https://www.kaggle.com/kwangyangchia/notebook-for-lesson-2-mle)
* [Notes from Sebastián Ayala Ruano](https://github.com/sayalaruano/100DaysOfMLCode/blob/main/Regression/Notes/NotesDay5.md)
* [Notes form Ayoub Berdeddouch](https://github.com/ayoub-berdeddouch/mlbookcamp-homeworks/blob/main/Regression/homework_Regression_AyoubBerdeddouch.ipynb)
* [Notes from Alvaro Navas](https://github.com/ziritrion/ml-zoomcamp/blob/main/notes/02_01-linear_regression.md)
* Add your notes here
