## 5. Deploying Machine Learning Models

- 5.1 [Intro / Session overview](01-intro.md)
- 5.2 [Saving and loading the model](02-pickle.md)
- 5.3 [Web services: introduction to Flask](03-flask-intro.md)
- 5.4 [Serving the churn model with Flask](04-flask-deployment.md)
- 5.5 [Python virtual environment: Pipenv](05-pipenv.md)
- 5.6 [Environment management: Docker](06-docker.md)
- 5.7 [Deployment to the cloud: AWS Elastic Beanstalk (optional)](07-aws-eb.md)
- 5.8 [Summary](08-summary.md)
- 5.9 [Explore more](09-explore-more.md)
- 5.10 [Homework](homework.md)


## Community notes

Did you take notes? You can share them here (or in each unit separately)

* [Notes from Alvaro Navas](https://github.com/ziritrion/ml-zoomcamp/blob/main/notes/05_01_deployment.md)
* [Docker notes](https://github.com/ayoub-berdeddouch/mlbookcamp-homeworks/blob/main/Deployment/README.md)
* Add your notes here

### Deployment tutorials

* [Using PythonAnywhere to host your Python Web App for free!!! (an an alternative to AWS/Azure/Google cloud)](https://github.com/nindate/ml-zoomcamp-exercises/blob/main/how-to-use-pythonanywhere.md)
* [Deploy Churn Service on Heroku](https://github.com/razekmaiden/churn_service_heroku.git)
* Add your tutorials here

